<template>
  <div class="chart-container">
    <div class="chart">
      <v-chart autoresize :option="option"/>

    </div>
    <!-- 底座背景 -->
    <div class="bg"/>
  </div>
</template>

<script>
// import { getPie3D, getParametricEquation } from 'chart.js' // 工具类js，页面路径自己修改
import * as echarts from 'echarts'
import {param} from '@/utils'
import {chartJxdxqky, chartSyjhdxqk} from '@/api/dashboard-json'

export default {
  name: 'Jxdxqk',
  data() {
    return {
      option: {},
      arrMap: []
    }
  },
  created() {
    this.getOption()
  },

  methods: {
    // 初始化label样式
    async getOption() {
      const res = await chartJxdxqky()
      if (res?.code === 200) {
        const arrMap = [
          res.info.series[0].data[0],
          res.info.series[1].data[0]
        ]
        this.arrMap = arrMap
      }

      /** ***********************
       pie3D 尝试

       更新时间: 2020.8.6 17:12 v1.1
       使用组件: grid3D、xAxis3D、yAxis3D、zAxis3D、surface
       EC 版本: 4.8.0
       GL 版本：0.4.3
       公众号 : ZXand618的ECharts之旅
       知乎号 : ZhXand618
       如果转载: 请注明出处

       *************************
       【 getParametricEquation 函数说明 】 :
       *************************
       根据传入的
       startRatio（浮点数）: 当前扇形起始比例，取值区间 [0, endRatio)
       endRatio（浮点数）: 当前扇形结束比例，取值区间 (startRatio, 1]
       isSelected（布尔值）:是否选中，效果参照二维饼图选中效果（单选）
       isHovered（布尔值）: 是否放大，效果接近二维饼图高亮（放大）效果（未能实现阴影）
       k（0~1之间的浮点数）：用于参数方程的一个参数，取值 0~1 之间，通过「内径/外径」的值换算而来。

       生成 3D 扇形环曲面

       *************************
       【 getPie3D 函数说明 】 :
       *************************
       根据传入的
       pieData（object）：饼图数据
       internalDiameterRatio（0~1之间的浮点数）：内径/外径的值（默认值 1/2），当该值等于 0 时，为普通饼图

       生成模拟 3D 饼图的配置项 option

       备注：饼图数据格式示意如下
       [{
        name: '数据1',
        value: 10
    }, {
        // 数据项名称
        name: '数据2',
        value : 56,
        itemStyle:{
            // 透明度
            opacity: 0.5,
            // 扇形颜色
            color: 'green'
        }
    }]

       *************************
       【 鼠标事件监听说明 】 :
       *************************
       click： 实现饼图的选中效果（单选）
       大致思路是，通过监听点击事件，获取到被点击数据的系列序号 params.seriesIndex，
       然后将对应扇形向外/向内移动 10% 的距离。

       mouseover： 近似实现饼图的高亮（放大）效果
       大致思路是，在饼图外部套一层透明的圆环，然后监听 mouseover 事件，获取
       到对应数据的系列序号 params.seriesIndex 或系列名称 params.seriesName，
       如果鼠标移到了扇形上，则先取消高亮之前的扇形（如果有）,再高亮当前扇形；
       如果鼠标移到了透明圆环上，则只取消高亮之前的扇形（如果有），不做任何高亮。

       globalout： 当鼠标移动过快，直接划出图表区域时，有可能监听不到透明圆环的 mouseover，
       导致此前高亮没能取消，所以补充了对 globalout 的监听。

       *************************/

      // 生成扇形的曲面参数方程，用于 series-surface.parametricEquation
      function getParametricEquation(startRatio, endRatio, isSelected, isHovered, k, height) {
        // 计算
        const midRatio = (startRatio + endRatio) / 2

        const startRadian = startRatio * Math.PI * 2
        const endRadian = endRatio * Math.PI * 2
        const midRadian = midRatio * Math.PI * 2

        // 如果只有一个扇形，则不实现选中效果。
        if (startRatio === 0 && endRatio === 1) {
          isSelected = false
        }

        // 通过扇形内径/外径的值，换算出辅助参数 k（默认值 1/3）
        k = typeof k !== 'undefined' ? k : 1 / 3

        // 计算选中效果分别在 x 轴、y 轴方向上的位移（未选中，则位移均为 0）
        const offsetX = isSelected ? Math.cos(midRadian) * 0.1 : 0
        const offsetY = isSelected ? Math.sin(midRadian) * 0.1 : 0

        // 计算高亮效果的放大比例（未高亮，则比例为 1）
        const hoverRate = isHovered ? 1.05 : 1

        // 返回曲面参数方程
        return {

          u: {
            min: -Math.PI,
            max: Math.PI * 3,
            step: Math.PI / 32
          },

          v: {
            min: 0,
            max: Math.PI * 2,
            step: Math.PI / 20
          },

          x: (u, v) => {
            if (u < startRadian) {
              return offsetX + Math.cos(startRadian) * (1 + Math.cos(v) * k) * hoverRate
            }
            if (u > endRadian) {
              return offsetX + Math.cos(endRadian) * (1 + Math.cos(v) * k) * hoverRate
            }
            return offsetX + Math.cos(u) * (1 + Math.cos(v) * k) * hoverRate
          },

          y: function(u, v) {
            if (u < startRadian) {
              return offsetY + Math.sin(startRadian) * (1 + Math.cos(v) * k) * hoverRate
            }
            if (u > endRadian) {
              return offsetY + Math.sin(endRadian) * (1 + Math.cos(v) * k) * hoverRate
            }
            return offsetY + Math.sin(u) * (1 + Math.cos(v) * k) * hoverRate
          },

          z: function(u, v) {
            if (u < -Math.PI * 0.5) {
              return Math.sin(u)
            }
            if (u > Math.PI * 2.5) {
              return Math.sin(u)
            }
            return Math.sin(v) > 0 ? 1 * height : -1
          }
        }
      }

      // 生成模拟 3D 饼图的配置项
      const getPie3D = (pieData, internalDiameterRatio) => {
        const series = []
        let sumValue = 0
        let startValue = 0
        let endValue = 0
        const legendData = []
        const k = typeof internalDiameterRatio !== 'undefined' ? (1 - internalDiameterRatio) / (1 + internalDiameterRatio) : 1 / 3

        // 为每一个饼图数据，生成一个 series-surface 配置
        for (let i = 0; i < pieData.length; i++) {
          sumValue += pieData[i].value

          const seriesItem = {
            name: typeof pieData[i].name === 'undefined' ? `series${i}` : pieData[i].name,
            type: 'surface',
            parametric: true,
            wireframe: {
              show: false
            },
            pieData: pieData[i],
            pieStatus: {
              selected: false,
              hovered: false,
              k: k
            }
          }

          if (typeof pieData[i].itemStyle !== 'undefined') {
            const itemStyle = {}

            typeof pieData[i].itemStyle.color !== 'undefined' ? itemStyle.color = pieData[i].itemStyle.color : null
            typeof pieData[i].itemStyle.opacity !== 'undefined' ? itemStyle.opacity = pieData[i].itemStyle.opacity : null

            seriesItem.itemStyle = itemStyle
            // seriesItem.itemStyle = pieData[i].itemStyle
          }
          series.push(seriesItem)
        }

        // 使用上一次遍历时，计算出的数据和 sumValue，调用 getParametricEquation 函数，
        // 向每个 series-surface 传入不同的参数方程 series-surface.parametricEquation，也就是实现每一个扇形。
        for (let i = 0; i < series.length; i++) {
          endValue = startValue + series[i].pieData.value
          console.log(series[i])
          series[i].pieData.startRatio = startValue / sumValue
          series[i].pieData.endRatio = endValue / sumValue
          series[i].parametricEquation = getParametricEquation(series[i].pieData.startRatio, series[i].pieData.endRatio, true, false, k, 1)

          startValue = endValue

          legendData.push(series[i].name)
        }

        // 补充一个透明的圆环，用于支撑高亮功能的近似实现。
        series.push({
          name: 'mouseoutSeries',
          type: 'surface',
          parametric: true,
          wireframe: {
            show: false
          },
          itemStyle: {
            opacity: 1,
            color: 'rgba(255,255,255,0.02)'
          },
          parametricEquation: {
            u: {
              min: 0,
              max: Math.PI * 2,
              step: Math.PI / 20
            },
            v: {
              min: 0,
              max: Math.PI,
              step: Math.PI / 1.4
            },
            x: function(u, v) {
              return Math.sin(v) * Math.sin(u) + Math.sin(u)
            },
            y: function(u, v) {
              return Math.sin(v) * Math.cos(u) + Math.cos(u)
            },
            z: function(u, v) {
              return Math.cos(v) > 0 ? 0.1 : -0.1
            }
          }
        })
        // 准备待返回的配置项，把准备好的 legendData、series 传入。
        const option = {
          tooltip: {
            formatter: params => {
              if (params.seriesName !== 'mouseoutSeries') {
                return `${params.seriesName}<br/><span style="display:inline-block;margin-right:5px;border-radius:10px;width:10px;height:10px;background-color:${params.color};"></span>${option.series[params.seriesIndex].pieData.value}`
              }
            }
          },
          // visualMap: {
          //   show: false,
          //   dimension: 2,
          //   min: -1,
          //   max: 1,
          //   inRange: {
          //     // color: ['#000de4', '#4575b4', '#74add1',]
          //   }
          // },
          legend: {
            data: legendData,
            position: 'right',
            selectedMode: false,
            right: '10%',
            top: '30%',
            width: '100%',
            // height: '',
            orient: 'vertical',
            textStyle: {
              color: '#fff',
              fontSize: this.EchartfontSize(14)
            }
          },
          labelLine: {
            show: true,
            lineStyle: {
              // color: '#7BC0CB'
            }
          },
          label: {
            show: true,
            position: 'outside',
            textStyle: {
              color: '#ffffff',
              fontSize: this.EchartfontSize(200)
            }
            // rich: {
            //   b: {
            //     color: '#7BC0CB',
            //     fontSize: this.EchartfontSize(20),
            //     lineHeight: this.EchartfontSize(100)
            //   },
            //   c: {
            //     fontSize: this.EchartfontSize(20)
            //   }
            // }
          },
          xAxis3D: {
            min: -1,
            max: 1
          },
          yAxis3D: {
            min: -1,
            max: 1
          },
          zAxis3D: {
            min: -1,
            max: 1
          },
          grid3D: {
            top: '-10%',
            show: false,
            boxHeight: 20,
            environment: undefined,
            viewControl: {
              distance: 260,
              alpha: 25,
              // beta: 130,
              beta: 0,
              rotateSensitivity: 0, // 设置为0无法旋转
              zoomSensitivity: 0, // 设置为0无法缩放
              panSensitivity: 0, // 设置为0无法平移
              autoRotate: false // 自动旋转
            }
          },
          series: series
        }
        return option
      }

      const optionData = [{
        name: '完成',
        value: this.arrMap[0],
        itemStyle: {
          opacity: 0.5,
          color: 'rgba(33,229,248,0.8)'
        }

      }, {
        name: '剩余',
        value: this.arrMap[1],
        itemStyle: {
          opacity: 0.5,
          color: 'rgba(217,187,62,0.8)'
        }
      }

      ]

      // 传入数据生成 option
      this.option = getPie3D(optionData, 0)

      this.option.series.push(
        {
          name: '', // 自己根据场景修改
          type: 'pie',
          hoverAnimation: false, // 悬停不放大
          labelLine: {
            length: this.EchartfontSize(30),
            length2: this.EchartfontSize(60),
            lineStyle: {
              width: this.EchartfontSize(2)
            }
          },
          label: {
            position: 'outside',
            padding: [0, -this.EchartfontSize(50)],
            formatter: (params) => {
              const arr = [
                `{a|${params.name}}`,
                `{b|${params.value}\n\n}`
              ]
              return arr.join(' ')
            },
            rich: {
              a: {
                color: '#ffffff',
                fontSize: this.EchartfontSize(14)
              },
              b: {
                color: 'rgba(33,229,248)',
                fontSize: this.EchartfontSize(14),
                verticalAlign: 'top',
                align: 'center'

              }
            }

          },
          startAngle: 25, // 起始角度，支持范围[0, 360]。
          clockwise: false, // 饼图的扇区是否是顺时针排布。上述这两项配置主要是为了对齐3d的样式
          radius: ['50%', '50%'],
          center: ['50%', '53%'],
          data: optionData,
          itemStyle: {
            opacity: 0 // 这里必须是0，不然2d的图会覆盖在表面
          }
        })
    }

  }
}
</script>

<style lang="less" scoped>
.chart-container {
  position: relative;
  width: 100%;
  height: 100%;
  margin-left: -3vw;

  .chart {
    width: 100%;
    height: 100%;
    position: absolute;
    z-index: 2;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
  }

  .bg {
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: -5vw;
    z-index: 1;
    width: 100%;
    background-repeat: no-repeat;
    background-image: url('/static/images/chart_opacity_bg.png');
    background-size: 22vh 15vh;
    background-position: center 28%;
  }
}
</style>
